#include <windows.h>
#include <gl/glut.h>
#include "Color.h"
#include "Vector.h"
#include "Hit.h"
#include "SceneObject.h"
#include "Sphere.h"
#include "Plane.h"

const int windowWidth = 400;
const int windowHeight = 400;

const int numObjects = 2;
SceneObject* objects[numObjects];

/*=======================================*/
/*== Insert background colour here     ==*/
/*=======================================*/
Color background = Color(0, 0, 0); 


/*=======================================*/
/*== Set up the camera and viewplane   ==*/
/*=======================================*/
Vector eye;
Vector u;
Vector v;
Vector n;
float N;
float W;
float H;


/*=======================================*/
/*== Set up the scene                  ==*/
/*=======================================*/
void setupScene()
{
	// insert scene objects here
}


/*============================================*/
/*== Implement the intersection method here ==*/
/*============================================*/
Hit intersect(Vector source, Vector d)
{
	Hit hit;
	
	return hit;
}


/*============================================*/
/*== Implement the shade method here        ==*/
/*============================================*/
Color shade(Hit hit)
{
	Color color;

	return color;
}


void display(void)
{
	glClear(GL_COLOR_BUFFER_BIT);
	glBegin(GL_POINTS);
	for(int r=0; r<windowHeight; r++) {
		for(int c=0; c<windowWidth; c++) {
			
			/*=======================================*/
			/*== Construct the ray                 ==*/
			/*=======================================*/


			/*=======================================*/
			/*== Intersect ray with scene objects  ==*/
			/*=======================================*/
			

			/*=======================================*/
			/*== Shade pixel accordingly           ==*/
			/*=======================================*/
			Color color; 
			glColor3f(color.r, color.g, color.b);
			glVertex2f((GLfloat)c, (GLfloat)r);
		}
	}
	glEnd();
	glFlush();
}

void init(void)
{
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(0, windowWidth, 0, windowHeight);
	setupScene();
}

int main(int argc, char** argv)
{
	glutInit(&argc, argv);		
	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
	glutInitWindowSize(windowWidth, windowHeight); 
	glutInitWindowPosition(100, 100);
	glutCreateWindow("Ray Tracer - Q1");
	init();
	glutDisplayFunc(display);
	glutMainLoop();
	return 0;
}
